# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from magneto_api_client.models.blueprint_properties_group import BlueprintPropertiesGroup
from typing import Optional, Set
from typing_extensions import Self

class BlueprintOptions(BaseModel):
    """
    BlueprintOptions
    """ # noqa: E501
    properties_groups: Optional[Dict[str, BlueprintPropertiesGroup]] = Field(default=None, alias="propertiesGroups")
    show_in_side_bar: Optional[StrictBool] = Field(default=True, description="Flag to show or hide blueprint in the sidebar", alias="showInSideBar")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["propertiesGroups", "showInSideBar"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BlueprintOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in properties_groups (dict)
        _field_dict = {}
        if self.properties_groups:
            for _key_properties_groups in self.properties_groups:
                if self.properties_groups[_key_properties_groups]:
                    _field_dict[_key_properties_groups] = self.properties_groups[_key_properties_groups].to_dict()
            _dict['propertiesGroups'] = _field_dict
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BlueprintOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "propertiesGroups": dict(
                (_k, BlueprintPropertiesGroup.from_dict(_v))
                for _k, _v in obj["propertiesGroups"].items()
            )
            if obj.get("propertiesGroups") is not None
            else None,
            "showInSideBar": obj.get("showInSideBar") if obj.get("showInSideBar") is not None else True
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


